from enum import Enum
from typing import Optional

from pydantic import BaseModel, Field


class BCDProtectionRequirements(Enum):
    """
    BCD Firewall Protection Requirements
    """
    LEVEL_1 = 1
    LEVEL_2 = 2
    SPECIAL = 10

class BCDSystemType(Enum):
    CLIENT = 1
    SERVER = 2
    PRINTER = 3
    IOT_DEVICES = 4
    VPN_WIFI_ONLY = 5
    OTHER = 6

class BCDRequestModel(BaseModel):
    oe: str = Field()
    group: str = Field()
    protection_requirement: BCDProtectionRequirements = Field()
    protection_requirement_note: Optional[str] = Field(default=None)
    type_of_system: BCDSystemType = Field()
    type_of_system_note: Optional[str] = Field(default=None)
    load_balancer: bool = Field()
